##
## clirc -- An IRC client in Python.
## dcc.py - DCC file transfer.
##
## Copyleft 1997-2001 Teemu Kalvas <chery@s2.org>
##

import reloadable
import runloop

class DCCSendServer(reloadable.Reloadable, runloop.ServerSocket):
    def __init__(self, name, end_hook):
	runloop.ServerSocket.__init__(self)
	self.name = name
        try:
            self.file = open(name)
        except IOError, msg:
            self.end_hook(self, msg)
        self.sender = None
        self.end_hook = end_hook

    def make_data_sock(self, data_sock, address):
	self.sender = DCCSend(data_sock, self.file, self)

    def disconnect(self):
        if self.sender:
            self.sender.disconnect()

reloadable.register_for_reload(DCCSendServer)

class DCCSend(reloadable.Reloadable, runloop.DataSocket):
    def __init__(self, sock, file, send_server):
	runloop.DataSocket.__init__(self, sock)
        self.send_server = send_server
        self.sent_amount = 0
	self.file = file
	self.read()
	self.write_or_terminate()

    def received(self, data):
	pass

    def write_or_terminate(self):
        try:
            data = self.file.read(8192)
        except IOError, msg:
            self.send_server.end_hook(self.send_server, msg)
            self.file.close()
            self.disconnect()
	if data:
	    self.write(data)
            self.sent_amount = self.sent_amount + len(data)
	else:
            self.send_server.end_hook(self.send_server, 0)
	    self.file.close()
            self.disconnect()

    def write_ready(self, sock):
	runloop.DataSocket.write_ready(self, sock)
	if not self.disconnecting and not self.write_queue:
	    self.write_or_terminate()

    def broken_pipe(self):
        self.send_server.end_hook(self.send_server,
                                  'Broken pipe on dcc connection')
        runloop.DataSocket.broken_pipe(self)

reloadable.register_for_reload(DCCSend)

class DCCReceive(reloadable.Reloadable, runloop.DataSocket):
    def __init__(self, address, size, name, end_hook):
	runloop.DataSocket.__init__(self)
        self.end_hook = end_hook
        try:
            self.file = open(name, 'w')
        except IOError, msg:
            self.end_hook(self, msg)
	self.received_amount = 0
	self.in_size = 8192
	self.connect(address)
	self.read()

    def received(self, data):
        try:
            self.file.write(data)
        except IOError, msg:
            self.end_hook(self, msg)
            self.file.close()
            self.disconnect()
	self.received_amount = self.received_amount + len(data)
	self.write(chr(self.received_amount >> 24)
		   + chr((self.received_amount >> 16) & 255)
		   + chr((self.received_amount >> 8) & 255)
		   + chr(self.received_amount & 255))

    def disconnected(self):
        if self.received_amount < self.size:
            self.end_hook(self, 'Sender disconnected dcc connection, file truncated at ' + repr(self.received_amount))
        else:
            self.end_hook(self, 0)
	self.file.close()
        runloop.DataSocket.disconnected(self)

    def broken_pipe(self):
        self.end_hook(self, 'Broken pipe on dcc connection')
        runloop.DataSocket.broken_pipe(self)

reloadable.register_for_reload(DCCReceive)

## End. ##
